/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PReqRoleInfoProc
 *  fire.pb.attr.SRefreshPetData
 *  fire.pb.attr.SRefreshRoleData
 *  fire.pb.battle.ai.BattleAIManager
 *  fire.pb.buff.BuffRoleImpl
 *  fire.pb.buff.continual.ConstantlyBuff
 *  fire.pb.effect.Module
 *  fire.pb.effect.PetImpl
 *  fire.pb.effect.RoleImpl
 *  fire.pb.main.ConfigManager
 *  fire.pb.main.ModuleInterface
 *  fire.pb.main.ModuleManager
 *  fire.pb.main.ReloadResult
 *  fire.pb.npc.SHireNpc
 *  fire.pb.pet.PetColumn
 *  fire.pb.skill.Module
 *  fire.pb.skill.Result
 *  fire.pb.team.SZhenFaeffect
 *  fire.pb.util.Parser
 *  fire.pb.util.Parser$ID2Odds
 *  fire.script.JavaScript
 *  mkdb.CacheQuery
 *  mkdb.Procedure
 *  mkdb.TTableCache
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xbean.BattleInfo
 *  xtable.Battle
 */
package fire.pb.battle;

import fire.pb.PReqRoleInfoProc;
import fire.pb.attr.SRefreshPetData;
import fire.pb.attr.SRefreshRoleData;
import fire.pb.battle.BattleConfig;
import fire.pb.battle.BattleConfigManager;
import fire.pb.battle.BattleField;
import fire.pb.battle.FormationConfig;
import fire.pb.battle.MonstershowConfigManager;
import fire.pb.battle.PBattleEnd;
import fire.pb.battle.SBattleInfo;
import fire.pb.battle.SEffectPostions;
import fire.pb.battle.SFormationConfig;
import fire.pb.battle.ai.BattleAIManager;
import fire.pb.buff.BuffRoleImpl;
import fire.pb.buff.continual.ConstantlyBuff;
import fire.pb.effect.PetImpl;
import fire.pb.effect.RoleImpl;
import fire.pb.main.ConfigManager;
import fire.pb.main.ModuleInterface;
import fire.pb.main.ModuleManager;
import fire.pb.main.ReloadResult;
import fire.pb.npc.SHireNpc;
import fire.pb.pet.PetColumn;
import fire.pb.skill.Result;
import fire.pb.team.SZhenFaeffect;
import fire.pb.util.Parser;
import fire.script.JavaScript;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.NavigableMap;
import java.util.Set;
import java.util.TreeMap;
import mkdb.CacheQuery;
import mkdb.Procedure;
import mkdb.TTableCache;
import mkio.Protocol;
import org.apache.log4j.Logger;
import xbean.BattleInfo;
import xtable.Battle;

public class Module
implements ModuleInterface {
    public static final String MODULE_NAME = "battle";
    private static final Logger logger = Logger.getLogger((String)"BATTLE");
    private final Map<Integer, Map<Integer, FormationConfig>> formLevelMap = new HashMap<Integer, Map<Integer, FormationConfig>>();
    private final Map<Integer, BattleConfig> battleConfigs = new HashMap<Integer, BattleConfig>();
    private NavigableMap<Integer, SEffectPostions> effectpostions;
    private Map<Integer, SHireNpc> buffnpcs = new HashMap<Integer, SHireNpc>();
    private MonstershowConfigManager monstershowConfigManager;

    public BattleConfigManager getBattleConfigManager() {
        return BattleConfigManager.getInstance();
    }

    public static Module getInstance() {
        return (Module)ModuleManager.getInstance().getModuleByName(MODULE_NAME);
    }

    public void exit() {
    }

    public ReloadResult reload() throws Exception {
        ReloadResult result = fire.pb.skill.Module.getInstance().reload();
        if (!result.isSuccess()) {
            return result.appendMsg("battle module reload failed, ");
        }
        try {
            Module m = new Module();
            m.init();
            ModuleManager.getInstance().putModuleByName(MODULE_NAME, (ModuleInterface)m);
            return result;
        }
        catch (Exception e) {
            logger.error((Object)e);
            return new ReloadResult(false, "battle module reload failed, ");
        }
    }

    public void init() throws Exception {
        logger.info((Object)"battle模块初始化开始");
        this.formLevelMap.clear();
        BattleConfigManager.getInstance().init(ConfigManager.getInstance());
        this.effectpostions = ConfigManager.getInstance().getConf(SEffectPostions.class);
        TreeMap sformbuffs = ConfigManager.getInstance().getConf(SFormationConfig.class);
        for (int i = 0; i < ((SFormationConfig)sformbuffs.get(0)).getPositions().size(); ++i) {
            Integer pstr = ((SFormationConfig)sformbuffs.get(0)).getPositions().get(i);
            FormationConfig.cposition2sposition.put(pstr, FormationConfig.bps[i]);
        }
        for (Object zfcfg : sformbuffs.values()) {
            FormationConfig.cposition2fightid.put(((SFormationConfig)zfcfg).id, ((SFormationConfig)zfcfg).positions);
        }
        TreeMap sformbuffsnew = ConfigManager.getInstance().getConf(SZhenFaeffect.class);
        for (SZhenFaeffect zfe : sformbuffsnew.values()) {
            float effectvalue;
            int effectId;
            String[] tmpstrs;
            String[] strs;
            String effectstrs;
            int i;
            int formId = zfe.getZhenfaid();
            int formLevel = zfe.getZhenfaLv();
            SFormationConfig formbuff = (SFormationConfig)sformbuffs.get(formId);
            String[] formMap = this.formLevelMap.get(formId);
            if (formMap == null) {
                formMap = new HashMap<Integer, FormationConfig>();
                this.formLevelMap.put(formId, (Map<Integer, FormationConfig>)formMap);
            }
            FormationConfig config = new FormationConfig(formId, formLevel);
            config.setExp(zfe.getZhenfaExp());
            if (zfe.getEffect() != null) {
                for (i = 0; i < zfe.getEffect().size(); ++i) {
                    effectstrs = (String)zfe.getEffect().get(i);
                    if (effectstrs == null || effectstrs.equals("") || effectstrs.equals("-1.0") || effectstrs.equals("null")) continue;
                    config.getEffects()[i] = new HashMap<Integer, Float>();
                    for (String str : strs = effectstrs.split(";")) {
                        tmpstrs = str.split("=");
                        effectId = fire.pb.effect.Module.getInstance().getIdByName(tmpstrs[0]);
                        effectvalue = Float.valueOf(tmpstrs[1]).floatValue();
                        config.getEffects()[i].put(effectId, Float.valueOf(effectvalue));
                    }
                }
            }
            config.setName(formbuff.name);
            if (zfe.getEffectloss() != null) {
                for (i = 0; i < zfe.getEffectloss().size(); ++i) {
                    effectstrs = (String)zfe.getEffectloss().get(i);
                    if (effectstrs == null || effectstrs.equals("") || effectstrs.equals("-1.0") || effectstrs.equals("null")) continue;
                    config.getSuppressEffects()[i] = new HashMap<Integer, Float>();
                    for (String str : strs = effectstrs.split(";")) {
                        tmpstrs = str.split("=");
                        effectId = fire.pb.effect.Module.getInstance().getIdByName(tmpstrs[0]);
                        effectvalue = Float.valueOf(tmpstrs[1]).floatValue();
                        config.getSuppressEffects()[i].put(effectId, Float.valueOf(effectvalue));
                    }
                }
            }
            if (formbuff.getPositions() != null) {
                for (i = 0; i < formbuff.getPositions().size(); ++i) {
                    BattleField.Position pos = FormationConfig.getSPosition(formbuff.getPositions().get(i));
                    config.getPositions().put(i + 1, pos);
                }
            }
            if (formbuff.getSuppress1() != null && formbuff.getSuppressparam1() != null) {
                String[] sup1;
                String s1 = formbuff.getSuppress1();
                Float param1 = Float.valueOf(Float.parseFloat(formbuff.getSuppressparam1()));
                Map<Integer, Float> map1 = config.getmapSuppressform1();
                for (String s : sup1 = s1.split(",")) {
                    Integer v = Integer.parseInt(s);
                    map1.put(v, param1);
                }
            }
            if (formbuff.getSuppress2() != null && formbuff.getSuppressparam2() != null) {
                String[] sup2;
                String s2 = formbuff.getSuppress2();
                Float param2 = Float.valueOf(Float.parseFloat(formbuff.getSuppressparam2()));
                Map<Integer, Float> map2 = config.getmapSuppressform2();
                for (String s : sup2 = s2.split(",")) {
                    Integer v = Integer.parseInt(s);
                    map2.put(v, param2);
                }
            }
            formMap.put(formLevel, (FormationConfig)config);
        }
        logger.info((Object)"battle阵型信息初始化完成");
        this.monstershowConfigManager = new MonstershowConfigManager(ConfigManager.getInstance());
        try {
            BattleAIManager.getInstance().initBattleAI();
        }
        catch (Exception e) {
            logger.error((Object)"Battle AI模块初始化错误。", (Throwable)e);
        }
        logger.info((Object)"battle AI信息初始化完成");
        TreeMap sBattleInfos = ConfigManager.getInstance().getConf(SBattleInfo.class);
        this.battleConfigs.clear();
        for (SBattleInfo sbattleInfo : sBattleInfos.values()) {
            try {
                BattleConfig battleconf = new BattleConfig();
                battleconf.id = sbattleInfo.id;
                battleconf.award = sbattleInfo.award;
                battleconf.fightAItype = sbattleInfo.fightAItype;
                battleconf.monsterNumScript = new JavaScript(sbattleInfo.monsterNumScript);
                battleconf.sceneId = sbattleInfo.scene;
                battleconf.environment = sbattleInfo.environment;
                battleconf.background = sbattleInfo.scene;
                battleconf.bgm = sbattleInfo.bgm;
                battleconf.victoryconditionType = sbattleInfo.victorycondition;
                battleconf.isNotDecEndure = sbattleInfo.isNotDecEndure;
                battleconf.xiezhannum = sbattleInfo.xiezhan;
                battleconf.cameratype = sbattleInfo.cameratype;
                if (sbattleInfo.battlelevel != null) {
                    battleconf.leveljs = new JavaScript(sbattleInfo.battlelevel);
                }
                if (sbattleInfo.battleAI != null && !sbattleInfo.battleAI.equals("0")) {
                    String[] strs;
                    for (String str : strs = sbattleInfo.battleAI.split(";")) {
                        battleconf.battleAIs.add(Float.valueOf(str).intValue());
                    }
                }
                if (sbattleInfo.randompos != null) {
                    String[] strs;
                    for (String str : strs = sbattleInfo.randompos.split(";")) {
                        battleconf.randomPos.add((int)Integer.valueOf(str));
                    }
                }
                if (sbattleInfo.positions.size() != 28) {
                    logger.error((Object)("战斗信息：" + battleconf.id + " 战斗点位信息不够28个。"));
                    continue;
                }
                for (int index = 0; index < sbattleInfo.positions.size(); ++index) {
                    Parser.ID2Odds id2odds;
                    String position = sbattleInfo.positions.get(index);
                    if (position.equals("0") || (id2odds = Parser.parseIdAndOdds((String)position)) == null) continue;
                    battleconf.monsterRands.put(index + 1, id2odds);
                }
                this.battleConfigs.put(battleconf.id, battleconf);
            }
            catch (Exception e) {
                logger.error((Object)"战场信息模块初始化错误。", (Throwable)e);
            }
        }
        logger.info((Object)"战场信息初始化完成");
        for (SHireNpc entry : ConfigManager.getInstance().getConf(SHireNpc.class).values()) {
            this.buffnpcs.put(entry.getBuffID(), entry);
        }
        logger.info((Object)"battle模块初始化完成");
    }

    public MonstershowConfigManager getMonstershowConfigManager() {
        return this.monstershowConfigManager;
    }

    public FormationConfig getFormationById(int formId, int formLevel) {
        Map<Integer, FormationConfig> levelFormBuff;
        if (formLevel == 0) {
            formId = 0;
        }
        if ((levelFormBuff = this.formLevelMap.get(formId)) != null) {
            return levelFormBuff.get(formLevel);
        }
        return null;
    }

    public Map<Integer, BattleConfig> getBattleConfigs() {
        return this.battleConfigs;
    }

    public NavigableMap<Integer, SEffectPostions> getEffectPostions() {
        return this.effectpostions;
    }

    public List<Integer> getDiffusePoss(int nindex) {
        if (this.effectpostions.get(nindex) != null) {
            return ((SEffectPostions)this.effectpostions.get((Object)Integer.valueOf((int)nindex))).diffuseposs;
        }
        if (BattleField.logger.isInfoEnabled()) {
            BattleField.logger.info((Object)("getDiffusePoss return null！！！   FighterId=" + nindex));
        }
        return null;
    }

    public List<Integer> getEffectPoss(int nindex) {
        if (this.effectpostions.get(nindex) != null) {
            return ((SEffectPostions)this.effectpostions.get((Object)Integer.valueOf((int)nindex))).effectposs;
        }
        if (BattleField.logger.isInfoEnabled()) {
            BattleField.logger.info((Object)("getEffectPoss return null！！！   FighterId=" + nindex));
        }
        return null;
    }

    public void checkBattleBuff(long roleid) {
        Result result;
        long res;
        ConstantlyBuff buff;
        BuffRoleImpl bri = new BuffRoleImpl(roleid, false);
        RoleImpl role = new RoleImpl(roleid, false);
        SRefreshRoleData sendrole = new SRefreshRoleData();
        if (bri.existBuff(500009) && role.getHp() != 0) {
            buff = bri.getBuff(500009);
            res = role.getUplimithp() - role.getHp();
            if (buff.getAmount() < res) {
                res = buff.getAmount();
            }
            if (res > 0L) {
                role.addHp((int)res);
                sendrole.datas.put(80, Float.valueOf(role.getHp()));
                buff.setAmount(buff.getAmount() - res);
                if (buff.getAmount() == 0L) {
                    this.removeRecoverBuff(bri, 500009);
                } else {
                    result = new Result(true);
                    result.addAddedBuff(buff);
                    bri.psendSBuffChangeResult(result);
                }
            }
        }
        if (bri.existBuff(500010) && role.getHp() != 0) {
            buff = bri.getBuff(500010);
            res = role.getMaxMp() - role.getMp();
            if (buff.getAmount() < res) {
                res = buff.getAmount();
            }
            if (res > 0L) {
                role.addMp((int)res);
                sendrole.datas.put(100, Float.valueOf(role.getMp()));
                buff.setAmount(buff.getAmount() - res);
                if (buff.getAmount() == 0L) {
                    this.removeRecoverBuff(bri, 500010);
                } else {
                    result = new Result(true);
                    result.addAddedBuff(buff);
                    bri.psendSBuffChangeResult(result);
                }
            }
        }
        if (!sendrole.datas.isEmpty()) {
            Procedure.psendWhileCommit((long)roleid, (Protocol)sendrole);
        }
        PetImpl pet = null;
        PetColumn depotcol = new PetColumn(roleid, 1, false);
        Set existIds = depotcol.getPetsMap().keySet();
        if (existIds.size() > 0) {
            Iterator iterator = existIds.iterator();
            while (iterator.hasNext()) {
                Result result2;
                long res2;
                ConstantlyBuff buff2;
                int petkey = (Integer)iterator.next();
                if (petkey == -1 || petkey == 0) continue;
                pet = new PetImpl(roleid, petkey, false);
                SRefreshPetData sendpet = new SRefreshPetData();
                if (bri.existBuff(500009)) {
                    buff2 = bri.getBuff(500009);
                    res2 = pet.getMaxHp() - pet.getHp();
                    if (buff2.getAmount() < res2) {
                        res2 = buff2.getAmount();
                    }
                    if (res2 > 0L) {
                        pet.addHp((int)res2);
                        sendpet.datas.put(80, Float.valueOf(pet.getHp()));
                        buff2.setAmount(buff2.getAmount() - res2);
                        if (buff2.getAmount() == 0L) {
                            this.removeRecoverBuff(bri, 500009);
                        } else {
                            result2 = new Result(true);
                            result2.addAddedBuff(buff2);
                            bri.psendSBuffChangeResult(result2);
                        }
                    }
                }
                if (bri.existBuff(500010) && pet != null) {
                    buff2 = bri.getBuff(500010);
                    res2 = pet.getMaxMp() - pet.getMp();
                    if (buff2.getAmount() < res2) {
                        res2 = buff2.getAmount();
                    }
                    if (res2 > 0L) {
                        pet.addMp((int)res2);
                        sendpet.datas.put(100, Float.valueOf(pet.getMp()));
                        buff2.setAmount(buff2.getAmount() - res2);
                        if (buff2.getAmount() == 0L) {
                            this.removeRecoverBuff(bri, 500010);
                        } else {
                            result2 = new Result(true);
                            result2.addAddedBuff(buff2);
                            bri.psendSBuffChangeResult(result2);
                        }
                    }
                }
                if (sendpet.datas.isEmpty()) continue;
                sendpet.columnid = 1;
                sendpet.petkey = petkey;
                Procedure.psendWhileCommit((long)roleid, (Protocol)sendpet);
            }
        }
        Procedure.pexecuteWhileCommit((Procedure)new PReqRoleInfoProc(roleid));
    }

    private boolean removeRecoverBuff(BuffRoleImpl bri, int buffId) {
        bri.removeCBuffWithSP(buffId);
        return false;
    }

    public SHireNpc getSHireNpcByBuffId(int buffId) {
        return this.buffnpcs.get(buffId);
    }

    public static void serverShutdown() {
        final HashMap battleresults = new HashMap();
        try {
            new Procedure(){

                protected boolean process() throws Exception {
                    TTableCache btable = Battle.getCache();
                    btable.walk((CacheQuery)new CacheQuery<Long, BattleInfo>(){

                        public void onQuery(Long battleId, BattleInfo battle) {
                            int result = 0;
                            result = battle.getBattletype() == 100 ? 0 : (battle.getBattletype() % 10 == 0 ? -1 : 0);
                            battleresults.put(battleId, result);
                        }
                    });
                    return true;
                }
            }.submit().get();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        for (Map.Entry entry : battleresults.entrySet()) {
            try {
                new PBattleEnd((Long)entry.getKey(), (Integer)entry.getValue()).submit().get();
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}

